Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2696)
@@ -575,318 +729,9 @@
 !> and plant canopy and it allocates the needed arrays for USM
 !------------------------------------------------------------------------------!
-    SUBROUTINE usm_allocate_urban_surface
+    SUBROUTINE usm_allocate_surface
     
         IMPLICIT NONE
        
-        INTEGER(iwp) :: i, j, k, d, l, ir, jr, ids, m
-        INTEGER(iwp) :: k_topo     !< vertical index indicating topography top for given (j,i)
-        INTEGER(iwp) :: k_topo2    !< vertical index indicating topography top for given (j,i)
-        INTEGER(iwp) :: nzubl, nzutl, isurf, ipcgb
-        INTEGER(iwp) :: procid
-
-        
-
-        
-!--     auxiliary vars
-        ddxy2 = (/ddy2,ddy2,ddx2,ddx2/)      !< 1/dx^2 or 1/dy^2 (in surface normal direction)
-        
-        CALL location_message( '', .TRUE. )
-        CALL location_message( '    allocation of needed arrays', .TRUE. )
-!
-!--     Find nzub, nzut, nzu via wall_flag_0 array (nzb_s_inner will be 
-!--     removed later). The following contruct finds the lowest / largest index
-!--     for any upward-facing wall (see bit 12). 
-        nzubl = MINVAL(                                                        &
-                    MAXLOC(                                                    &
-                          MERGE( 1, 0,                                         &
-                                 BTEST( wall_flags_0(:,nys:nyn,nxl:nxr), 12 )  &
-                               ), DIM = 1                                      &
-                          ) - 1                                                & 
-                            )
-        nzutl = MAXVAL(                                                        &
-                   MAXLOC(                                                     &
-                          MERGE( 1, 0,                                         &
-                                 BTEST( wall_flags_0(:,nys:nyn,nxl:nxr), 12 )  &
-                               ), DIM = 1                                      &
-                          ) - 1                                                &
-                            )
-        nzubl = max(nzubl,nzb)
-
-        
-        IF ( plant_canopy )  THEN
-!--         allocate needed arrays
-            ALLOCATE( pct(nys:nyn,nxl:nxr) )
-            ALLOCATE( pch(nys:nyn,nxl:nxr) )
-
-!--         calculate plant canopy height
-            npcbl = 0
-            pct = 0.0_wp
-            pch = 0.0_wp
-            DO i = nxl, nxr
-                DO j = nys, nyn
-!
-!--                 Find topography top index
-                    k_topo = get_topography_top_index( j, i, 's' )
-
-                    DO k = nzt+1, 0, -1
-                        IF ( lad_s(k,j,i) /= 0.0_wp )  THEN
-!--                         we are at the top of the pcs
-                            pct(j,i) = k + k_topo
-                            pch(j,i) = k
-                            npcbl = npcbl + pch(j,i)
-                            EXIT
-                        ENDIF
-                    ENDDO
-                ENDDO
-            ENDDO
-            
-            nzutl = max(nzutl, maxval(pct))
-!--         code of plant canopy model uses parameter pch_index
-!--         we need to setup it here to right value
-!--         (pch_index, lad_s and other arrays in PCM are defined flat)
-            pch_index = maxval(pch)
-
-            prototype_lad = maxval(lad_s) * .9_wp  !< better be *1.0 if lad is either 0 or maxval(lad) everywhere
-            IF ( prototype_lad <= 0._wp ) prototype_lad = .3_wp
-            !WRITE(message_string, '(a,f6.3)') 'Precomputing effective box optical ' &
-            !    // 'depth using prototype leaf area density = ', prototype_lad
-            !CALL message('usm_init_urban_surface', 'PA0520', 0, 0, -1, 6, 0)
-        ENDIF
-        
-        nzutl = min(nzutl+nzut_free, nzt)
-                  
-#if defined( __parallel )
-        CALL MPI_AllReduce(nzubl,nzub,1,MPI_INTEGER,MPI_MIN,comm2d,ierr);
-        CALL MPI_AllReduce(nzutl,nzut,1,MPI_INTEGER,MPI_MAX,comm2d,ierr);
-#else
-        nzub = nzubl
-        nzut = nzutl
-#endif
-
-!--     global number of urban layers
-        nzu = nzut - nzub + 1
-        
-!--     allocate urban surfaces grid
-!--     calc number of surfaces in local proc
-        CALL location_message( '    calculation of indices for surfaces', .TRUE. )
-        nsurfl = 0
-!
-!--     Number of land- and roof surfaces. Note, since horizontal surface elements
-!--     are already counted in surface_mod, in case be simply reused here.
-        startland = 1
-        nsurfl    = surf_usm_h%ns
-        endland   = nsurfl
-        nlands    = endland-startland+1
-
-!
-!--     Number of vertical surfaces. As vertical surfaces are already 
-!--     counted in surface mod, it can be reused here. 
-        startwall = nsurfl+1
-        nsurfl = nsurfl + surf_usm_v(0)%ns + surf_usm_v(1)%ns +        &
-                          surf_usm_v(2)%ns + surf_usm_v(3)%ns 
-        endwall = nsurfl
-        nwalls = endwall-startwall+1
-
-        
-!--     range of energy balance surfaces  ! will be treated separately by surf_usm_h and surf_usm_v
-        nenergy = 0
-        IF ( usm_energy_balance_land )  THEN
-            startenergy = startland
-            nenergy = nenergy + nlands
-        ELSE
-            startenergy = startwall
-        ENDIF
-        IF ( usm_energy_balance_wall )  THEN
-            endenergy = endwall
-            nenergy = nenergy + nwalls
-        ELSE
-            endenergy = endland
-        ENDIF
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!--     block of virtual surfaces
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!--     calculate sky surfaces  ! not used so far!
-        startsky = nsurfl+1
-        nsurfl = nsurfl+(nxr-nxl+1)*(nyn-nys+1)
-        endsky = nsurfl
-        nskys = endsky-startsky+1
-        
-!--     border flags
-#if defined( __parallel )
-        isborder = (/ north_border_pe, south_border_pe, right_border_pe, left_border_pe /)
-#else
-        isborder = (/.TRUE.,.TRUE.,.TRUE.,.TRUE./)
-#endif
-!--     fill array of the limits of the local domain borders
-        ijdb = RESHAPE( (/ nxl,nxr,nyn,nyn,nxl,nxr,nys,nys,nxr,nxr,nys,nyn,nxl,nxl,nys,nyn /), (/4, 4/) )
-!--     calulation of the free borders of the domain
-        DO  ids = 6,9
-           IF ( isborder(ids) )  THEN
-!--           free border of the domain in direction ids
-              DO  i = ijdb(1,ids), ijdb(2,ids)
-                 DO  j = ijdb(3,ids), ijdb(4,ids)
-
-                    k_topo  = get_topography_top_index( j, i, 's' )
-                    k_topo2 = get_topography_top_index( j-jdir(ids), i-idir(ids), 's' )
-
-                    k = nzut - MAX( k_topo, k_topo2 )
-                    nsurfl = nsurfl + k
-                 ENDDO
-              ENDDO
-           ENDIF
-        ENDDO
-        
-!--     fill gridpcbl and pcbl
-        IF ( plant_canopy )  THEN
-            ALLOCATE( pcbl(iz:ix, 1:npcbl) )
-            ALLOCATE( gridpcbl(nzub:nzut,nys:nyn,nxl:nxr) )
-            gridpcbl(:,:,:) = 0
-            ipcgb = 0
-            DO i = nxl, nxr
-                DO j = nys, nyn
-!
-!--                 Find topography top index
-                    k_topo = get_topography_top_index( j, i, 's' )
-
-                    DO k = k_topo + 1, pct(j,i)
-                        ipcgb = ipcgb + 1
-                        gridpcbl(k,j,i) = ipcgb
-                        pcbl(:,ipcgb) = (/ k, j, i /)
-                    ENDDO
-                ENDDO
-            ENDDO
-
-            ALLOCATE( pcbinsw( 1:npcbl ) )
-            ALLOCATE( pcbinlw( 1:npcbl ) )
-        ENDIF
-
-!--     fill surfl
-        ALLOCATE(surfl(5,nsurfl))
-        isurf = 0
-        
-!--     add land surfaces or roofs
-        DO i = nxl, nxr
-            DO j = nys, nyn
-               DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                  k = surf_usm_h%k(m)
-
-                  isurf = isurf + 1
-                  surfl(:,isurf) = (/iroof,k,j,i,m/)
-               ENDDO
-            ENDDO
-        ENDDO
-
-!--     add walls
-        DO i = nxl, nxr
-            DO j = nys, nyn
-               l = 0
-               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
-                  k = surf_usm_v(l)%k(m)
-
-                  isurf          = isurf + 1
-                  surfl(:,isurf) = (/2,k,j,i,m/)
-               ENDDO
-               l = 1
-               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
-                  k = surf_usm_v(l)%k(m)
-
-                  isurf          = isurf + 1
-                  surfl(:,isurf) = (/1,k,j,i,m/)
-               ENDDO
-               l = 2
-               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
-                  k = surf_usm_v(l)%k(m)
-
-                  isurf          = isurf + 1
-                  surfl(:,isurf) = (/4,k,j,i,m/)
-               ENDDO
-               l = 3
-               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
-                  k = surf_usm_v(l)%k(m)
-
-                  isurf          = isurf + 1
-                  surfl(:,isurf) = (/3,k,j,i,m/)
-               ENDDO
-            ENDDO
-        ENDDO
-
-!--     add sky
-        DO i = nxl, nxr
-            DO j = nys, nyn
-                isurf = isurf + 1
-                k = nzut
-                surfl(:,isurf) = (/isky,k,j,i,-1/)
-            ENDDO
-        ENDDO
-        
-!--     calulation of the free borders of the domain
-        DO ids = 6,9
-            IF ( isborder(ids) )  THEN
-!--             free border of the domain in direction ids
-                DO i = ijdb(1,ids), ijdb(2,ids)
-                    DO j = ijdb(3,ids), ijdb(4,ids)
-                        k_topo  = get_topography_top_index( j, i, 's' )
-                        k_topo2 = get_topography_top_index( j-jdir(ids), i-idir(ids), 's' )
-
-                        DO k = MAX(k_topo,k_topo2)+1, nzut
-                            isurf = isurf + 1
-                            surfl(:,isurf) = (/ids,k,j,i,-1/)
-                        ENDDO
-                    ENDDO
-                ENDDO
-            ENDIF
-        ENDDO
-        
-!--     global array surf of indices of surfaces and displacement index array surfstart
-        ALLOCATE(nsurfs(0:numprocs-1))
-        
-#if defined( __parallel )
-        CALL MPI_Allgather(nsurfl,1,MPI_INTEGER,nsurfs,1,MPI_INTEGER,comm2d,ierr)
-#else
-        nsurfs(0) = nsurfl
-#endif
-        ALLOCATE(surfstart(0:numprocs))
-        k = 0
-        DO i=0,numprocs-1
-            surfstart(i) = k
-            k = k+nsurfs(i)
-        ENDDO
-        surfstart(numprocs) = k
-        nsurf = k
-        ALLOCATE(surf(5,nsurf))
-        
-#if defined( __parallel )
-        CALL MPI_AllGatherv(surfl, nsurfl*5, MPI_INTEGER, surf, nsurfs*5, surfstart*5, MPI_INTEGER, comm2d, ierr)
-#else
-        surf = surfl
-#endif
-        
-!--
-!--     allocation of the arrays for direct and diffusion radiation
-        CALL location_message( '    allocation of radiation arrays', .TRUE. )
-!--     rad_sw_in, rad_lw_in are computed in radiation model,
-!--     splitting of direct and diffusion part is done
-!--     in usm_calc_diffusion_radiation for now
-        ALLOCATE( rad_sw_in_dir(nysg:nyng,nxlg:nxrg) )
-        ALLOCATE( rad_sw_in_diff(nysg:nyng,nxlg:nxrg) )
-        ALLOCATE( rad_lw_in_diff(nysg:nyng,nxlg:nxrg) )
-        
-!--     allocate radiation arrays
-        ALLOCATE( surfins(nsurfl) )
-        ALLOCATE( surfinl(nsurfl) )
-        ALLOCATE( surfinsw(nsurfl) )
-        ALLOCATE( surfinlw(nsurfl) )
-        ALLOCATE( surfinswdir(nsurfl) )
-        ALLOCATE( surfinswdif(nsurfl) )
-        ALLOCATE( surfinlwdif(nsurfl) )
-        ALLOCATE( surfoutsl(startenergy:endenergy) )
-        ALLOCATE( surfoutll(startenergy:endenergy) )
-        ALLOCATE( surfoutsw(startenergy:endenergy) )
-        ALLOCATE( surfoutlw(startenergy:endenergy) )
-        ALLOCATE( surfouts(nsurf) ) !TODO: global surfaces without virtual
-        ALLOCATE( surfoutl(nsurf) ) !TODO: global surfaces without virtual
-
-
+        INTEGER(iwp) ::  l
 
 !
@@ -896,18 +741,8 @@
         ALLOCATE( surf_usm_h%rad_net_l(1:surf_usm_h%ns) )
 !
-!--  New
-        ALLOCATE( surf_usm_h%rad_in_sw(1:surf_usm_h%ns)  )
-        ALLOCATE( surf_usm_h%rad_out_sw(1:surf_usm_h%ns) )
-        ALLOCATE( surf_usm_h%rad_in_lw(1:surf_usm_h%ns)  )
-        ALLOCATE( surf_usm_h%rad_out_lw(1:surf_usm_h%ns) )
-!
 !--     For vertical surfaces
         DO  l = 0, 3
            ALLOCATE( surf_usm_v(l)%surfhf(1:surf_usm_v(l)%ns)    )
            ALLOCATE( surf_usm_v(l)%rad_net_l(1:surf_usm_v(l)%ns) )
-           ALLOCATE( surf_usm_v(l)%rad_in_sw(1:surf_usm_v(l)%ns)  )
-           ALLOCATE( surf_usm_v(l)%rad_out_sw(1:surf_usm_v(l)%ns) )
-           ALLOCATE( surf_usm_v(l)%rad_in_lw(1:surf_usm_v(l)%ns)  )
-           ALLOCATE( surf_usm_v(l)%rad_out_lw(1:surf_usm_v(l)%ns) )
         ENDDO
 
@@ -920,43 +755,92 @@
            ALLOCATE( surf_usm_v(l)%surface_types(1:surf_usm_v(l)%ns) )
         ENDDO
-       
-!--     broadband albedo of the land, roof and wall surface
-!--     for domain border and sky set artifically to 1.0
-!--     what allows us to calculate heat flux leaving over
-!--     side and top borders of the domain
-        ALLOCATE ( albedo_surf(nsurfl) )
-        albedo_surf = 1.0_wp
-        ALLOCATE ( surf_usm_h%albedo_surf(1:surf_usm_h%ns) )
+!
+!--     Allocate albedo_type and albedo. Each surface element
+!--     has 3 values, 0: wall fraction, 1: green fraction, 2: window fraction.
+        ALLOCATE( surf_usm_h%albedo_type(0:2,1:surf_usm_h%ns) )
+        ALLOCATE( surf_usm_h%albedo(0:2,1:surf_usm_h%ns)      )
+        surf_usm_h%albedo_type = albedo_type
         DO  l = 0, 3
-           ALLOCATE( surf_usm_v(l)%albedo_surf(1:surf_usm_v(l)%ns) )
-        ENDDO
+           ALLOCATE( surf_usm_v(l)%albedo_type(0:2,1:surf_usm_v(l)%ns) )
+           ALLOCATE( surf_usm_v(l)%albedo(0:2,1:surf_usm_v(l)%ns)      )
+           surf_usm_v(l)%albedo_type = albedo_type
+        ENDDO       
+
+
+!
+!--     Allocate indoor target temperature for summer and winter
+        ALLOCATE( surf_usm_h%target_temp_summer(1:surf_usm_h%ns) )
+        ALLOCATE( surf_usm_h%target_temp_winter(1:surf_usm_h%ns) )
+        DO  l = 0, 3
+           ALLOCATE( surf_usm_v(l)%target_temp_summer(1:surf_usm_v(l)%ns) )
+           ALLOCATE( surf_usm_v(l)%target_temp_winter(1:surf_usm_v(l)%ns) )
+        ENDDO   
+!
+!--     Allocate flag indicating ground floor level surface elements
+        ALLOCATE ( surf_usm_h%ground_level(1:surf_usm_h%ns) ) 
+        DO  l = 0, 3
+           ALLOCATE( surf_usm_v(l)%ground_level(1:surf_usm_v(l)%ns) )
+        ENDDO   
+!
+!--      Allocate arrays for relative surface fraction. 
+!--      0 - wall fraction, 1 - green fraction, 2 - window fraction
+         ALLOCATE( surf_usm_h%frac(0:2,1:surf_usm_h%ns) )
+         surf_usm_h%frac = 0.0_wp
+         DO  l = 0, 3
+            ALLOCATE( surf_usm_v(l)%frac(0:2,1:surf_usm_v(l)%ns) )
+            surf_usm_v(l)%frac = 0.0_wp
+         ENDDO
        
 !--     wall and roof surface parameters. First for horizontal surfaces
-        ALLOCATE ( emiss_surf(startenergy:endenergy) )
-
-        ALLOCATE ( surf_usm_h%isroof_surf(1:surf_usm_h%ns)    )
-        ALLOCATE ( surf_usm_h%emiss_surf(1:surf_usm_h%ns)     )
-        ALLOCATE ( surf_usm_h%lambda_surf(1:surf_usm_h%ns)    )
-        ALLOCATE ( surf_usm_h%c_surface(1:surf_usm_h%ns)      )
-        ALLOCATE ( surf_usm_h%roughness_wall(1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%isroof_surf(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%lambda_surf(1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%lambda_surf_window(1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%lambda_surf_green(1:surf_usm_h%ns)  )
+        ALLOCATE ( surf_usm_h%c_surface(1:surf_usm_h%ns)       )
+        ALLOCATE ( surf_usm_h%c_surface_window(1:surf_usm_h%ns)   )
+        ALLOCATE ( surf_usm_h%c_surface_green(1:surf_usm_h%ns)    )
+        ALLOCATE ( surf_usm_h%transmissivity(1:surf_usm_h%ns)  )
+        ALLOCATE ( surf_usm_h%lai(1:surf_usm_h%ns)             )
+        ALLOCATE ( surf_usm_h%emissivity(0:2,1:surf_usm_h%ns)  )
+
 !
 !--     For vertical surfaces.
         DO  l = 0, 3
-           ALLOCATE ( surf_usm_v(l)%emiss_surf(1:surf_usm_v(l)%ns)     )
-           ALLOCATE ( surf_usm_v(l)%lambda_surf(1:surf_usm_v(l)%ns)    )
-           ALLOCATE ( surf_usm_v(l)%c_surface(1:surf_usm_v(l)%ns)      )
-           ALLOCATE ( surf_usm_v(l)%roughness_wall(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%lambda_surf(1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%c_surface(1:surf_usm_v(l)%ns)       )
+           ALLOCATE ( surf_usm_v(l)%lambda_surf_window(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%c_surface_window(1:surf_usm_v(l)%ns)   )
+           ALLOCATE ( surf_usm_v(l)%lambda_surf_green(1:surf_usm_v(l)%ns)  )
+           ALLOCATE ( surf_usm_v(l)%c_surface_green(1:surf_usm_v(l)%ns)    )
+           ALLOCATE ( surf_usm_v(l)%transmissivity(1:surf_usm_v(l)%ns)  )
+           ALLOCATE ( surf_usm_v(l)%lai(1:surf_usm_v(l)%ns)             )
+
+           ALLOCATE ( surf_usm_v(l)%emissivity(0:2,1:surf_usm_v(l)%ns)  )
         ENDDO
-       
+
+!       
 !--     allocate wall and roof material parameters. First for horizontal surfaces
         ALLOCATE ( surf_usm_h%thickness_wall(1:surf_usm_h%ns)               )
+        ALLOCATE ( surf_usm_h%thickness_window(1:surf_usm_h%ns)                  )
+        ALLOCATE ( surf_usm_h%thickness_green(1:surf_usm_h%ns)                   )
         ALLOCATE ( surf_usm_h%lambda_h(nzb_wall:nzt_wall,1:surf_usm_h%ns)   )
         ALLOCATE ( surf_usm_h%rho_c_wall(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%lambda_h_window(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%rho_c_window(nzb_wall:nzt_wall,1:surf_usm_h%ns)    )
+        ALLOCATE ( surf_usm_h%lambda_h_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
+        ALLOCATE ( surf_usm_h%rho_c_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)     )
+
 !
 !--     For vertical surfaces.
         DO  l = 0, 3
            ALLOCATE ( surf_usm_v(l)%thickness_wall(1:surf_usm_v(l)%ns)               )
+           ALLOCATE ( surf_usm_v(l)%thickness_window(1:surf_usm_v(l)%ns)                  )
+           ALLOCATE ( surf_usm_v(l)%thickness_green(1:surf_usm_v(l)%ns)                   )
            ALLOCATE ( surf_usm_v(l)%lambda_h(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)   )
            ALLOCATE ( surf_usm_v(l)%rho_c_wall(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%lambda_h_window(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%rho_c_window(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)    )
+           ALLOCATE ( surf_usm_v(l)%lambda_h_green(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)  )
+           ALLOCATE ( surf_usm_v(l)%rho_c_green(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)     )
         ENDDO
 
@@ -964,16 +848,38 @@
         ALLOCATE ( zwn(nzb_wall:nzt_wall) )
         ALLOCATE ( surf_usm_h%dz_wall(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)     )
+        ALLOCATE ( zwn_window(nzb_wall:nzt_wall) )
+        ALLOCATE ( surf_usm_h%dz_window(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)     )
+        ALLOCATE ( zwn_green(nzb_wall:nzt_wall) )
+        ALLOCATE ( surf_usm_h%dz_green(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)      )
         ALLOCATE ( surf_usm_h%ddz_wall(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)    )
         ALLOCATE ( surf_usm_h%dz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
         ALLOCATE ( surf_usm_h%ddz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
         ALLOCATE ( surf_usm_h%zw(nzb_wall:nzt_wall,1:surf_usm_h%ns)            )
+        ALLOCATE ( surf_usm_h%ddz_window(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)    )
+        ALLOCATE ( surf_usm_h%dz_window_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
+        ALLOCATE ( surf_usm_h%ddz_window_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%zw_window(nzb_wall:nzt_wall,1:surf_usm_h%ns)       )
+        ALLOCATE ( surf_usm_h%ddz_green(nzb_wall:nzt_wall+1,1:surf_usm_h%ns)     )
+        ALLOCATE ( surf_usm_h%dz_green_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)   )
+        ALLOCATE ( surf_usm_h%ddz_green_stag(nzb_wall:nzt_wall,1:surf_usm_h%ns)  )
+        ALLOCATE ( surf_usm_h%zw_green(nzb_wall:nzt_wall,1:surf_usm_h%ns)        )
 !
 !--     For vertical surfaces.
         DO  l = 0, 3
            ALLOCATE ( surf_usm_v(l)%dz_wall(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%dz_window(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%dz_green(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns)      )
            ALLOCATE ( surf_usm_v(l)%ddz_wall(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns)    )
            ALLOCATE ( surf_usm_v(l)%dz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)  )
            ALLOCATE ( surf_usm_v(l)%ddz_wall_stag(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
            ALLOCATE ( surf_usm_v(l)%zw(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)            )
+           ALLOCATE ( surf_usm_v(l)%ddz_window(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns)    )
+           ALLOCATE ( surf_usm_v(l)%dz_window_stag(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)  )
+           ALLOCATE ( surf_usm_v(l)%ddz_window_stag(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%zw_window(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)       )
+           ALLOCATE ( surf_usm_v(l)%ddz_green(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%dz_green_stag(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)   )
+           ALLOCATE ( surf_usm_v(l)%ddz_green_stag(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)  )
+           ALLOCATE ( surf_usm_v(l)%zw_green(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns)        )
         ENDDO
 
@@ -988,4 +894,28 @@
         IF ( .NOT. ALLOCATED( t_wall_h_p ) )                                   &           
            ALLOCATE ( t_wall_h_p(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )  
+        IF ( .NOT. ALLOCATED( t_surf_window_h ) )                              &
+           ALLOCATE ( t_surf_window_h(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_window_h_p ) )                            &
+           ALLOCATE ( t_surf_window_h_p(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_window_h ) )                                   &           
+           ALLOCATE ( t_window_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( t_window_h_p ) )                                 &           
+           ALLOCATE ( t_window_h_p(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )  
+        IF ( .NOT. ALLOCATED( t_surf_green_h ) )                               &
+           ALLOCATE ( t_surf_green_h(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_green_h_p ) )                             &
+           ALLOCATE ( t_surf_green_h_p(1:surf_usm_h%ns) )           
+        IF ( .NOT. ALLOCATED( t_green_h ) )                                    &           
+           ALLOCATE ( t_green_h(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( t_green_h_p ) )                                  &           
+           ALLOCATE ( t_green_h_p(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )  
+        IF ( .NOT. ALLOCATED( t_surf_whole_h ) )                               &
+           ALLOCATE ( t_surf_whole_h(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_whole_h_p ) )                             &
+           ALLOCATE ( t_surf_whole_h_p(1:surf_usm_h%ns) )           
+        IF ( .NOT. ALLOCATED( t_surf_10cm_h ) )                                &
+           ALLOCATE ( t_surf_10cm_h(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_10cm_h_p ) )                              &
+           ALLOCATE ( t_surf_10cm_h_p(1:surf_usm_h%ns) )
 #else
 !
@@ -1000,8 +930,39 @@
         IF ( .NOT. ALLOCATED( t_wall_h_2 ) )                                   &           
            ALLOCATE ( t_wall_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )          
+        IF ( .NOT. ALLOCATED( t_surf_window_h_1 ) )                            &
+           ALLOCATE ( t_surf_window_h_1(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_window_h_2 ) )                            &
+           ALLOCATE ( t_surf_window_h_2(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_window_h_1 ) )                                 &           
+           ALLOCATE ( t_window_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( t_window_h_2 ) )                                 &           
+           ALLOCATE ( t_window_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )          
+        IF ( .NOT. ALLOCATED( t_surf_green_h_1 ) )                             &
+           ALLOCATE ( t_surf_green_h_1(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_green_h_2 ) )                             &
+           ALLOCATE ( t_surf_green_h_2(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_green_h_1 ) )                                  &           
+           ALLOCATE ( t_green_h_1(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) ) 
+        IF ( .NOT. ALLOCATED( t_green_h_2 ) )                                  &           
+           ALLOCATE ( t_green_h_2(nzb_wall:nzt_wall+1,1:surf_usm_h%ns) )          
+        IF ( .NOT. ALLOCATED( t_surf_whole_h_1 ) )                             &
+           ALLOCATE ( t_surf_whole_h_1(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_whole_h_2 ) )                             &
+           ALLOCATE ( t_surf_whole_h_2(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_10cm_h_1 ) )                              &
+           ALLOCATE ( t_surf_10cm_h_1(1:surf_usm_h%ns) )
+        IF ( .NOT. ALLOCATED( t_surf_10cm_h_2 ) )                              &
+           ALLOCATE ( t_surf_10cm_h_2(1:surf_usm_h%ns) )
 !           
 !--     initial assignment of the pointers
         t_wall_h    => t_wall_h_1;    t_wall_h_p    => t_wall_h_2
+        t_window_h    => t_window_h_1;    t_window_h_p    => t_window_h_2
+        t_green_h    => t_green_h_1;    t_green_h_p    => t_green_h_2
         t_surf_h => t_surf_h_1; t_surf_h_p => t_surf_h_2           
+        t_surf_window_h => t_surf_window_h_1; t_surf_window_h_p => t_surf_window_h_2  
+        t_surf_green_h => t_surf_green_h_1; t_surf_green_h_p => t_surf_green_h_2           
+        t_surf_whole_h => t_surf_whole_h_1; t_surf_whole_h_p => t_surf_whole_h_2
+        t_surf_10cm_h => t_surf_10cm_h_1; t_surf_10cm_h_p => t_surf_10cm_h_2  
+ 
 #endif
 
@@ -1017,4 +978,28 @@
            IF ( .NOT. ALLOCATED( t_wall_v_p(l)%t ) )                           &                 
               ALLOCATE ( t_wall_v_p(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_window_v(l)%t ) )                      &
+              ALLOCATE ( t_surf_window_v(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_window_v_p(l)%t ) )                    &
+              ALLOCATE ( t_surf_window_v_p(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_window_v(l)%t ) )                           &
+              ALLOCATE ( t_window_v(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_window_v_p(l)%t ) )                         &                 
+              ALLOCATE ( t_window_v_p(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_green_v(l)%t ) )                            &
+              ALLOCATE ( t_green_v(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_green_v_p(l)%t ) )                          &                 
+              ALLOCATE ( t_green_v_p(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_green_v(l)%t ) )                       &
+              ALLOCATE ( t_surf_green_v(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_green_v_p(l)%t ) )                     &
+              ALLOCATE ( t_surf_green_v_p(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_whole_v(l)%t ) )                       &
+              ALLOCATE ( t_surf_whole_v(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_whole_v_p(l)%t ) )                     &
+              ALLOCATE ( t_surf_whole_v_p(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_10cm_v(l)%t ) )                        &
+              ALLOCATE ( t_surf_10cm_v(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_10cm_v_p(l)%t ) )                        &
+              ALLOCATE ( t_surf_10cm_v_p(l)%t(1:surf_usm_v(l)%ns) )
         ENDDO
 #else
@@ -1031,4 +1016,28 @@
            IF ( .NOT. ALLOCATED( t_wall_v_2(l)%t ) )                           &           
               ALLOCATE ( t_wall_v_2(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )  
+           IF ( .NOT. ALLOCATED( t_surf_window_v_1(l)%t ) )                    &
+              ALLOCATE ( t_surf_window_v_1(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_window_v_2(l)%t ) )                    &
+              ALLOCATE ( t_surf_window_v_2(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_window_v_1(l)%t ) )                         &           
+              ALLOCATE ( t_window_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) ) 
+           IF ( .NOT. ALLOCATED( t_window_v_2(l)%t ) )                         &           
+              ALLOCATE ( t_window_v_2(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )  
+           IF ( .NOT. ALLOCATED( t_surf_green_v_1(l)%t ) )                     &
+              ALLOCATE ( t_surf_green_v_1(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_green_v_2(l)%t ) )                     &
+              ALLOCATE ( t_surf_green_v_2(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_green_v_1(l)%t ) )                          &           
+              ALLOCATE ( t_green_v_1(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) ) 
+           IF ( .NOT. ALLOCATED( t_green_v_2(l)%t ) )                          &           
+              ALLOCATE ( t_green_v_2(l)%t(nzb_wall:nzt_wall+1,1:surf_usm_v(l)%ns) )  
+           IF ( .NOT. ALLOCATED( t_surf_whole_v_1(l)%t ) )                     &
+              ALLOCATE ( t_surf_whole_v_1(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_whole_v_2(l)%t ) )                     &
+              ALLOCATE ( t_surf_whole_v_2(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_10cm_v_1(l)%t ) )                     &
+              ALLOCATE ( t_surf_10cm_v_1(l)%t(1:surf_usm_v(l)%ns) )
+           IF ( .NOT. ALLOCATED( t_surf_10cm_v_2(l)%t ) )                     &
+              ALLOCATE ( t_surf_10cm_v_2(l)%t(1:surf_usm_v(l)%ns) )
         ENDDO
 !
@@ -1036,4 +1045,11 @@
         t_wall_v    => t_wall_v_1;    t_wall_v_p    => t_wall_v_2
         t_surf_v => t_surf_v_1; t_surf_v_p => t_surf_v_2
+        t_window_v    => t_window_v_1;    t_window_v_p    => t_window_v_2
+        t_green_v    => t_green_v_1;    t_green_v_p    => t_green_v_2
+        t_surf_window_v => t_surf_window_v_1; t_surf_window_v_p => t_surf_window_v_2
+        t_surf_green_v => t_surf_green_v_1; t_surf_green_v_p => t_surf_green_v_2
+        t_surf_whole_v => t_surf_whole_v_1; t_surf_whole_v_p => t_surf_whole_v_2
+        t_surf_10cm_v => t_surf_10cm_v_1; t_surf_10cm_v_p => t_surf_10cm_v_2
+
 #endif
 !
